Removing subshell for compatibility with Jenkins
[osm/vim-emu.git] / utils / ci / check_manual_usage_example.sh
1 #!/bin/bash
2 export DOCKER_HOST="unix:///var/run/docker.sock"
3
4 set -e
5 set -x
6
7 W() {
8 # Wait until a line appears in the screen session.
9 # It starts from the beginning of the log and exits after the first match.
10 local T=${2:-20s}
11 #timeout -k 3s ${T} stdbuf -o0 grep -q -m 1 "^${1}" <(tail -F -n+0 screenlog.0)
12 # (HACK) As Jenkins blocks subshell, we must use an intermediate script
13 local SUBF=$(mktemp)
14 chmod +x ${SUBF}
15 cat > ${SUBF} <<- EOF
16 #!/bin/bash -e
17 while true; do
18 if strings screenlog.0 | grep -m 1 "\${1}"; then
19 exit 0
20 fi
21 sleep 0.5s
22 done
23 EOF
24 timeout -k 3s ${T} ${SUBF} "${1}"
25 local RES=$?
26 rm -f ${SUBF}
27 return ${RES}
28 }
29
30 Cmd() {
31 # Send a command to the screen session, aka into the containernet prompt
32 screen -S sonemu -X stuff "${1}^M"
33 }
34
35
36 if ! screen --version | grep 'Screen version'; then
37 # Install screen and do an initial cleanup
38 sudo apt-get update -qq -y
39 sudo apt-get install -y screen
40 screen --version | grep 'Screen version'
41 fi
42 # Initial cleanup
43 pkill 'screen' || true
44 screen -wipe || true
45 rm -f screenlog.0
46
47
48 # Start containernet with a topology
49 screen -L -S sonemu -d -m python src/emuvim/examples/simple_topology.py
50 # Setup screen for immediate flusing
51 screen -S sonemu -X logfile flush 0
52 # Wait for the cli to start
53 W '^*** Starting CLI:'
54 # Print nodes
55 Cmd 'nodes'
56 # Start vnf1
57 son-emu-cli compute start -d datacenter1 -n vnf1 && sleep 1s
58 # Start vnf2
59 son-emu-cli compute start -d datacenter1 -n vnf2 && sleep 1s
60 # List compute nodes
61 son-emu-cli compute list && sleep 1s
62 # Gather some infos
63 Cmd 'sh echo "... starting various checks"'
64 sync # avoid test overlapping
65 Cmd 'vnf1 ifconfig && echo "... checked vnf1"'
66 W "^... checked vnf1"
67 Cmd 'vnf2 ifconfig && echo "... checked vnf2"'
68 W "^... checked vnf2"
69 # Try to ping vnfs
70 Cmd 'vnf1 ping -c 2 vnf2 || echo "... checked ping"'
71 W "^... checked ping" 20s
72 Cmd 'quit'
73 # Wait for sonemu to end
74 W '^*** Done'
75
76 echo -e '\n\n******************* Result ******************\n\n'
77 strings screenlog.0
78 echo -e '\n\n*********************************************\n\n'
79
80
81 # Check the ping result
82 if grep ', 2 received' screenlog.0; then
83 echo 'No problems detected'
84 exit 0
85 else
86 echo 'Ping is broken !'
87 exit 1
88 fi